Fix API breakage caused by OS Plugin version scan
[releng/global-jjb.git] / shell / tox-run.sh
index 3bf1576..6b45116 100644 (file)
 ##############################################################################
 echo "---> tox-run.sh"
 
+# shellcheck source=/tmp/v/tox/bin/activate disable=SC1091
+source "/tmp/v/tox/bin/activate"
+
 # Ensure we fail the job if any steps fail.
 # DO NOT set -u as virtualenv's activate script has unbound variables
 set -e -o pipefail
 
 ARCHIVE_TOX_DIR="$WORKSPACE/archives/tox"
 mkdir -p "$ARCHIVE_TOX_DIR"
-
 cd "$WORKSPACE/$TOX_DIR"
 
-if [ -z "$TOX_ENVS" ]; then
-    TOX_ENVS=$(crudini --get tox.ini tox envlist)
+if [ -d "/opt/pyenv" ]; then
+    echo "---> Setting up pyenv"
+    export PYENV_ROOT="/opt/pyenv"
+    export PATH="$PYENV_ROOT/bin:$PATH"
 fi
 
-run_tox() {
-    local log_dir="$1"
-    local env="$2"
+set +e  # Allow detox to fail so that we can collect the logs in the next step
 
-    # Sleep a random 10 second interval to workaround tox sdist
-    # conflicts due to building in the same dist directory.
-    sleep $[ ( $RANDOM % 10 )  + 1 ]s
-
-    echo "-----> Running tox $env"
-    if ! tox -e $env > "$log_dir/tox-$env.log"; then
-        echo "$env" >> "$log_dir/failed-envs.log"
+PARALLEL="${PARALLEL:-true}"
+if [ "${PARALLEL}" = true ]; then
+    if [ ! -z "$TOX_ENVS" ]; then
+        detox -e "$TOX_ENVS"  | tee -a "$ARCHIVE_TOX_DIR/detox.log"
+        tox_status="${PIPESTATUS[0]}"
+    else
+        detox | tee -a "$ARCHIVE_TOX_DIR/detox.log"
+        tox_status="${PIPESTATUS[0]}"
     fi
-}
-
-TOX_ENVS=(${TOX_ENVS//,/ })
-if hash parallel 2>/dev/null; then
-    export -f run_tox
-    parallel --jobs 200% "run_tox $ARCHIVE_TOX_DIR {}" ::: ${TOX_ENVS[*]}
 else
-    for env in "${TOX_ENVS[@]}"; do
-        run_tox "$ARCHIVE_TOX_DIR" "$env"
-    done
+    if [ ! -z "$TOX_ENVS" ]; then
+        tox -e "$TOX_ENVS"  | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    else
+        tox | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    fi
 fi
 
-if [ -f "$ARCHIVE_TOX_DIR/failed-envs.log" ]; then
-    failed_envs=($(cat "$ARCHIVE_TOX_DIR/failed-envs.log"))
-    echo "ERROR: Failed the following builds: ${failed_envs[*]}"
-    exit 1
-fi
+# Disable SC2116 as we want to echo a space separated list of TOX_ENVS
+# shellcheck disable=SC2116
+for i in .tox/*/log; do
+    tox_env=$(echo $i | awk -F'/' '{print $2}')
+    cp -r "$i" "$ARCHIVE_TOX_DIR/$tox_env"
+done
+set -e  # Logs collected so re-enable
 
 echo "Completed tox runs."
+
+test "$tox_status" -eq 0 || exit "$tox_status"